/************************************************/
/*						*/
/*      Copyright:				*/
/*		 Jean-Marc Pigeon <jmp@safe.ca>	*/
/*	Distributed under the Gnu Public	*/
/*	License, see the License file in this	*/
/*	package.				*/
/*						*/
/*	Define module level routines to handle	*/
/*	"CLAMAV" anti-virus management		*/
/*						*/
/************************************************/
#ifndef GESCLM
#define GESCLM

typedef enum	{
	clm_clean,	/*no virus detected	*/
	clm_virus,	/*virus detected	*/
	clm_nocheck	/*nocheck done		*/
	}CLMCHKTYP;

typedef	void CLAMTYP;

extern CLAMTYP *clm_refreshtree(CLAMTYP *clamav);
extern CLAMTYP *clm_opentree(CLAMTYP *clamav);
extern CLAMTYP *clm_closetree(CLAMTYP *clamav);
extern CLMCHKTYP clm_checkvirus(CLAMTYP *clamav,char *filename,
			        const char **virname);
extern const char *clm_getversdate(CLAMTYP *clamav);
#endif
