#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 8 "geshdr.y"
/*force le debugging du YACC                    */
#ifdef	DEBUG
#define lint    1
#define YYDEBUG 1
#endif

#include	<string.h>
#include	<setjmp.h>
#include	<syslog.h>
#include	<stdlib.h>
#include	"geshdr.h"
#include	"subrou.h"

int yyparse();		/*syntax parser		*/
static int yylex();	/*lexical parser	*/

/*preamble static function declaration		*/
static int skipfor(char);
static void yyerror(char *);
static char *strmix(char *,char,char *);




typedef	enum	{	/*header type frame	*/
	hd_from,	/*From:			*/
	hd_to,		/*To:			*/
	hd_cc,		/*Cc:			*/
	hd_bcc,		/*Bcc:			*/
	hd_sender,	/*Sender: 		*/
	hd_replyto,	/*Reply-To: 		*/
	hd_inreplyto,	/*In-Reply-To: 		*/
	hd_references,	/*References: 		*/
	hd_msgid,	/*Message-ID:		*/
	hd_subject,	/*Subject:		*/
	hd_date		/*Date:			*/
	}HIDTYP;

typedef	struct	{
	HIDTYP field;	/*header field type	*/	
	union {
	  char *time;	/*header date		*/
	  char *address;/*From address		*/
	  char *subject;/*Subject		*/
	  char **maddr;	/*To address		*/
	  }info;
	}HDRTYP;

static HDRTYP **ghdrs;	/*header collected info	*/
static int itsok;	/*parsing status	*/
static jmp_buf manystop;/*YACC fully lost	*/
static int cptstop=0;	/*stop received counting*/

static char **lines;	/*data-header pointer	*/
static int numline;	/*next char header line	*/
static int numrow;	/*next char header row	*/
static int curline;	/*cur char header line	*/
static int currow;	/*cur char header row	*/
static int nbrerr;	/*nombre d'erreur	*/


/*

*/
/************************************************/
/*						*/
/*	Procedure to create the memory space	*/
/*	for a header line			*/
/*						*/
/************************************************/
static HDRTYP *genheader(HIDTYP field,void *infos)

{
HDRTYP *header;

header=(HDRTYP *)calloc(1,sizeof(HDRTYP));
header->field=field;
switch (field) {
  case (hd_from)	:
  case (hd_sender)	:
  case (hd_replyto)	:
  case (hd_msgid)	:
  case (hd_date)	:
    header->info.address=(char *)infos;
    break;
  case (hd_to)		:
  case (hd_cc)		:
  case (hd_bcc)		:
  case (hd_references)	:
  case (hd_inreplyto)	:
    header->info.maddr=(char **)infos;
    break;
  case (hd_subject)	:
    header->info.subject=(char *)infos;
    break;
  default		:
    (void) tracing(LOG_DEBUG,0,"geshdr.y,genheader: Unexpected field "
			       "(bug?)");
    break;
  }
return header;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to add a header component to	*/
/*	the header list.			*/
/*						*/
/************************************************/
static HDRTYP **addhdrs(HDRTYP **chdrs,HDRTYP *header)

{
if (header!=(HDRTYP *)0) {
  chdrs=(HDRTYP **)rou_addveclst((void **)chdrs,(void *)header);
  }
return chdrs;
}
#line 129 "geshdr.y"
typedef union  {
	HDRTYP **hdrs;	/*full header parsed	*/
	HDRTYP *header;	/*one line header	*/
	char *string;	/*the info is a string	*/
	char punct;	/*one char only		*/
	char *word;	/*the info is a word	*/
	char *email;	/*the info is an E-mail	*/
	char **mboxes;	/*multiple Mail boxes	*/
	void *generic;	/*generic value		*/
	long time;	/*time value as a long	*/
	char *strtime;	/*time as a str(long)	*/
	int symbol;	/*token numeric value	*/
	long integer;	/*the value is integer	*/
	float floatting;/*the value is a float	*/
	} YYSTYPE;
#line 153 "y.tab.c"
#define YYERRCODE 256
#define STOP 257
#define CRLF 258
#define COLON 259
#define SEMICOL 260
#define COMMA 261
#define AT 262
#define DOT 263
#define MINUS 264
#define PLUS 265
#define PARLEFT 266
#define PARRIGHT 267
#define BRKLEFT 268
#define BRKRIGHT 269
#define LESSTHAN 270
#define GRTRTHAN 271
#define QUESTION 272
#define DEBENCOD 273
#define ENCODFIN 274
#define PUNCT 275
#define DATE 276
#define RDATE 277
#define FROM 278
#define SUBJECT 279
#define REPLYTO 280
#define INRPLYTO 281
#define RFERENCE 282
#define SENDER 283
#define MSGID 284
#define TO 285
#define CC 286
#define BCC 287
#define WORD 288
#define STRING 289
#define JAN 290
#define FEB 291
#define MAR 292
#define APR 293
#define MAY 294
#define JUN 295
#define JUL 296
#define AUG 297
#define SEP 298
#define OCT 299
#define NOV 300
#define DEC 301
#define MON 302
#define TUE 303
#define WED 304
#define THU 305
#define FRI 306
#define SAT 307
#define SUN 308
const short yylhs[] = {                                        -1,
    0,    0,    1,    1,    2,    3,    3,    3,    3,    3,
    3,    8,    8,    8,    8,    4,   10,   10,   10,    5,
    5,   12,   12,   14,    7,    7,    7,    7,   15,   17,
   19,   18,   18,   20,   20,   16,   16,   16,   16,   16,
    6,    6,   23,   24,   25,   25,   27,   27,   28,   29,
   29,   29,   32,   32,   34,   35,   33,   33,   37,   37,
   38,   38,   39,   39,   13,   13,   13,   42,   42,   42,
   41,   41,   11,   11,   11,   11,   11,   11,   11,   21,
   21,   22,   22,   22,   22,   45,   45,   45,   46,   46,
   47,   47,   48,   44,   44,   44,   44,   50,   43,   43,
   43,   40,   40,   51,   40,   30,   49,   49,    9,    9,
    9,    9,   52,   52,   52,   52,   53,   53,   53,   53,
   53,   53,   53,   31,   31,   31,   31,   31,   31,   31,
   31,   31,   31,   31,   31,   26,   26,   26,   26,   26,
   26,   26,   36,   36,   36,
};
const short yylen[] = {                                         2,
    2,    2,    1,    2,    2,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    1,    0,    1,    2,    3,    3,    2,    1,    1,
    1,    1,    3,    3,    3,    1,    2,    1,    3,    2,
    1,    1,    5,    3,    1,    1,    3,    1,    3,    0,
    1,    2,    1,    1,    1,    1,    0,    4,    3,    3,
    1,    3,    1,    2,    1,    2,    2,    2,    1,    3,
    2,    1,    3,    3,    4,    1,    3,    3,    1,    1,
    1,    2,    3,    4,    3,    2,    3,    3,    1,    2,
    2,    1,    1,    0,    3,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    2,
};
const short yydefred[] = {                                      0,
    0,  114,  115,   13,   14,  116,  113,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   10,
  124,  125,  126,  127,  128,  129,  130,  131,  132,  133,
  134,  135,  137,  138,  139,  140,  141,  142,  136,    0,
    0,    3,    0,    6,    7,    8,    9,   11,   12,    0,
    0,    0,    0,    0,    0,   41,   42,  111,  112,  109,
  110,    2,    0,    0,   17,   28,   19,   30,   31,   18,
   29,   22,   23,   24,   15,    1,    4,    5,    0,  104,
  117,  121,  123,  122,  118,  119,  120,  107,  103,  108,
   16,    0,    0,   99,    0,    0,  102,   71,   20,    0,
   66,    0,   21,    0,   39,   40,   25,   34,   26,    0,
   27,  106,   43,    0,   46,    0,    0,   44,    0,   96,
    0,    0,    0,    0,   77,   74,    0,    0,  101,  100,
   78,    0,    0,    0,   38,    0,    0,    0,   35,    0,
  143,    0,    0,   47,   55,    0,   52,    0,    0,    0,
    0,    0,   86,    0,   90,   91,   95,   97,    0,  105,
    0,    0,    0,   72,   69,    0,   36,   37,   45,  145,
   58,   50,    0,    0,   49,    0,   98,    0,   92,   94,
    0,   68,   56,    0,    0,   57,   93,   88,   87,    0,
   64,    0,   61,   63,   53,   59,   62,
};
const short yydgoto[] = {                                      40,
   41,   42,   43,   44,   45,   46,   47,   48,   90,   50,
   98,   51,   99,   52,   53,  108,   54,  109,   55,  110,
   92,   93,   56,   57,  113,   58,  115,  116,  144,  117,
   59,  146,  147,  148,  184,  149,  186,  192,  193,   94,
  100,  101,   95,   96,  152,  153,  154,  155,   97,  123,
  124,   60,   61,
};
const short yysindex[] = {                                    -98,
 -248,    0,    0,    0,    0,    0,    0, -232, -223, -200,
 -198, -189, -183, -175, -152, -149, -121,  -94,  -89,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -151,    0, -161,    0,    0,    0,    0,    0,    0,  509,
  509,  509,  644,  644,  644,    0,    0,    0,    0,    0,
    0,    0,  755,  755,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  370,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -241, -216,    0,    9,  599,    0,    0,    0, -145,
    0,  -44,    0,  554,    0,    0,    0,    0,    0,  644,
    0,    0,    0, -101,    0, -247,  776,    0,  689,    0,
 -100,   62,  599,  -83,    0,    0,  689,  168,    0,    0,
    0,  221,  509,  323,    0,  -96, -240,  221,    0, -112,
    0,  -48,    0,    0,    0, -244,    0,  -42, -112, -112,
  599, -229,    0,  734,    0,    0,    0,    0,  -53,    0,
  -41,  599,  221,    0,    0, -179,    0,    0,    0,    0,
    0,    0, -112,  -43,    0,  115,    0,  274,    0,    0,
  221,    0,    0,  -40,  464,    0,    0,    0,    0, -112,
    0,  417,    0,    0,    0,    0,    0,
};
const short yyrindex[] = {                                      0,
  -34,    0,    0,    0,    0,    0,    0,  -33,    0,  -31,
    0,  -28,    0,    0,  -25,    0,  -23,  -21,  -20,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -18,  -18,    0,    8,    8,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -157,    0,    0,  -99, -143,    0,    0,    0,   10,
    0, -173,    0,    0,    0,    0,    0,    0,    0,   11,
    0,    0,    0,    0,    0,   12,    0,    0,    0,    0,
    0, -170,    0,    0,    0,    0, -162,    0,    0,    0,
    0,  -47,    0,    0,    0,    0,    0, -238,    0,    0,
    0,  -17, -136,    0,    0,   14,    0,    0,    0,    0,
    0,    0,    0, -192,    0,    0,    0,    0,    0,    0,
  794, -213, -211,    0,    0,   17,    0,    0,    0,    0,
    0,    0,    0,   18,    0,    0,    0,    0,    0,    0,
 -188,    0,    0, -251,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,
};
const short yygindex[] = {                                      0,
    0,  226,    0,    0,    0,    0,    0,    0,    2,    0,
  -46,    0,  225,    0,    0,  -45,    0,  223,    0,    0,
  -69,  176,    0,    0,  219,  105,  146,    0,    0, -110,
  171,    0,  144,    0,  101,    0,    0,    0,  127,  -90,
  159,    0,  -51,  -76,  193,  143,    0,    0, -116,    0,
    0,    0,    0,
};
#define YYTABLESIZE 1077
const short yytable[] = {                                     102,
  102,   49,  156,   91,  130,  145,   54,  107,   62,  121,
  156,  130,   54,   54,  125,  126,  141,  142,  131,  141,
  142,  127,  128,   82,   82,  131,   63,  122,   79,  177,
  168,  130,   82,  178,  136,   64,   54,  179,  174,  175,
  143,  130,   49,  171,  132,  127,  128,  130,   84,   84,
   83,   83,  138,  159,  106,  106,  106,   84,   65,   83,
   66,  156,  183,   89,  139,   89,   89,   89,   89,   67,
   89,  138,  130,   85,   85,   68,  163,   89,   89,  183,
  182,  133,   85,   69,   79,  130,  164,   79,   82,   82,
  130,   82,   82,   81,  194,   81,   78,   81,   81,  176,
   73,  194,   73,   73,   75,   76,   70,   81,   81,   71,
  181,  106,    2,    3,   75,  133,   75,   75,    4,    5,
    6,   58,  106,    7,    8,    9,   10,   11,   12,   13,
   14,   15,   16,   17,   18,   19,   20,   72,   21,   22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
   33,   34,   35,   36,   37,   38,   39,    1,   79,  140,
   79,   79,   82,   82,   73,    2,    3,  114,  114,   74,
  157,    4,    5,    6,  167,  112,    7,    8,    9,   10,
   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
  160,   21,   22,   23,   24,   25,   26,   27,   28,   29,
   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,
   76,  129,   76,   76,  134,  170,  173,  180,  190,    2,
    3,  178,  185,   15,  117,   79,  121,    6,   80,  123,
    7,   81,  122,   82,  118,   83,  119,  120,   84,   67,
   85,   86,   87,   88,   89,   21,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
   36,   37,   38,   39,  129,   33,   77,   65,   32,   48,
  144,   51,    2,    3,   70,   60,  103,  111,   79,  137,
    6,   80,  118,    7,   81,  169,   82,  150,   83,  172,
  195,   84,  166,   85,   86,   87,   88,   89,   21,   22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
   33,   34,   35,   36,   37,   38,   39,  129,  197,  161,
  189,    0,    0,    0,    0,    2,    3,    0,    0,    0,
    0,    0,  158,    6,   80,    0,    7,   81,    0,   82,
    0,   83,    0,    0,   84,    0,   85,   86,   87,   88,
   89,   21,   22,   23,   24,   25,   26,   27,   28,   29,
   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,
  129,    0,    0,    0,    0,    0,    0,    0,    2,    3,
    0,    0,    0,  187,    0,    0,    6,   80,    0,    7,
   81,    0,   82,    0,   83,    0,    0,   84,    0,   85,
   86,   87,   88,   89,   21,   22,   23,   24,   25,   26,
   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,
   37,   38,   39,  162,    0,    0,    0,    0,    0,    0,
    0,    2,    3,    0,    0,    0,    0,    0,    0,    6,
   80,    0,    7,   81,    0,   82,    0,   83,    0,    0,
   84,    0,   85,   86,   87,   88,   89,   21,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,
   34,   35,   36,   37,   38,   39,  129,    0,    0,    0,
    0,    0,    0,    0,    2,    3,    0,    0,    0,    0,
    0,    0,    6,   80,    0,    7,   81,    0,   82,    0,
   83,    0,    0,   84,    0,   85,   86,   87,   88,   89,
   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
   31,   32,   33,   34,   35,   36,   37,   38,   39,  188,
    0,    0,    0,    0,    0,    0,    0,    2,    3,    0,
    0,  151,    0,    0,    0,    6,    0,    0,    7,   81,
    0,   82,    0,   83,    0,    0,   84,    0,   85,   86,
   87,   88,    0,   21,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,
   38,   39,  165,    0,    0,    0,    2,    3,    0,    0,
    0,    0,   79,    0,    6,   80,    0,    7,   81,    0,
   82,    0,   83,    0,    0,   84,    0,   85,   86,   87,
   88,   89,   21,   22,   23,   24,   25,   26,   27,   28,
   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
   39,  119,    0,    2,    3,    0,    0,    0,    0,    0,
  120,    6,   80,    0,    7,   81,    0,   82,    0,   83,
    0,    0,   84,    0,   85,   86,   87,   88,   89,   21,
   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
   32,   33,   34,   35,   36,   37,   38,   39,  191,    0,
    2,    3,    0,  196,    0,    0,    0,    0,    6,   80,
    0,    7,   81,    0,   82,    0,   83,    0,    0,   84,
    0,   85,   86,   87,   88,   89,   21,   22,   23,   24,
   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
   35,   36,   37,   38,   39,  191,    0,    2,    3,    0,
    0,    0,    0,    0,    0,    6,   80,    0,    7,   81,
    0,   82,    0,   83,    0,    0,   84,    0,   85,   86,
   87,   88,   89,   21,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,
   38,   39,    2,    3,    0,    0,    0,    0,   79,    0,
    6,   80,    0,    7,   81,    0,   82,    0,   83,    0,
    0,   84,    0,   85,   86,   87,   88,   89,   21,   22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
   33,   34,   35,   36,   37,   38,   39,    2,    3,    0,
    0,    0,    0,    0,  135,    6,   80,    0,    7,   81,
    0,   82,    0,   83,    0,    0,   84,    0,   85,   86,
   87,   88,   89,   21,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,
   38,   39,    2,    3,    0,    0,    0,    0,    0,    0,
    6,   80,    0,    7,   81,    0,   82,    0,   83,    0,
    0,   84,    0,   85,   86,   87,   88,   89,   21,   22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
   33,   34,   35,   36,   37,   38,   39,    2,    3,    0,
    0,    0,    0,  104,    0,    6,    0,    0,    7,   81,
    0,   82,    0,   83,    0,    0,   84,    0,   85,   86,
   87,  105,    0,   21,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,
   38,   39,    2,    3,    0,    0,  151,    0,    0,    0,
    6,    0,    0,    7,   81,    0,   82,    0,   83,    0,
    0,   84,    0,   85,   86,   87,   88,    0,   21,   22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
   33,   34,   35,   36,   37,   38,   39,    2,    3,    0,
    0,    0,    0,    0,    0,    6,    0,    0,    7,   81,
    0,   82,    0,   83,    0,    0,   84,    0,   85,   86,
   87,   88,    0,   21,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,
   38,   39,  112,    0,    0,    0,    0,    0,    0,   80,
    0,   80,    0,   80,   80,    0,   33,   34,   35,   36,
   37,   38,   39,   80,   80,   21,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,
};
const short yycheck[] = {                                      51,
   52,    0,  119,   50,   95,  116,  258,   53,  257,   79,
  127,  102,  264,  265,  256,   92,  264,  265,   95,  264,
  265,  262,  263,  262,  263,  102,  259,   79,  270,  259,
  271,  122,  271,  263,  104,  259,  288,  154,  149,  150,
  288,  132,   41,  288,   96,  262,  263,  138,  262,  263,
  262,  263,  104,  123,   53,   54,   55,  271,  259,  271,
  259,  178,  173,  256,  110,  258,  259,  260,  261,  259,
  263,  123,  163,  262,  263,  259,  128,  270,  271,  190,
  260,  261,  271,  259,  258,  176,  133,  261,  262,  263,
  181,  262,  263,  256,  185,  258,  258,  260,  261,  151,
  258,  192,  260,  261,  256,  257,  259,  270,  271,  259,
  162,  110,  264,  265,  258,  261,  260,  261,  270,  271,
  272,  258,  259,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  259,  290,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
  302,  303,  304,  305,  306,  307,  308,  256,  258,  261,
  260,  261,  262,  263,  259,  264,  265,   63,   64,  259,
  271,  270,  271,  272,  271,  288,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  274,  290,  291,  292,  293,  294,  295,  296,  297,  298,
  299,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  258,  256,  260,  261,  259,  264,  259,  271,  259,  264,
  265,  263,  266,  258,  258,  270,  258,  272,  273,  258,
  275,  276,  258,  278,  258,  280,  258,  258,  283,  258,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  256,  258,   41,  258,  258,  258,
  288,  258,  264,  265,  258,  258,   52,   55,  270,  104,
  272,  273,   64,  275,  276,  140,  278,  117,  280,  146,
  190,  283,  134,  285,  286,  287,  288,  289,  290,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
  302,  303,  304,  305,  306,  307,  308,  256,  192,  127,
  178,   -1,   -1,   -1,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,  272,  273,   -1,  275,  276,   -1,  278,
   -1,  280,   -1,   -1,  283,   -1,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,  297,  298,
  299,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  256,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  264,  265,
   -1,   -1,   -1,  269,   -1,   -1,  272,  273,   -1,  275,
  276,   -1,  278,   -1,  280,   -1,   -1,  283,   -1,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  300,  301,  302,  303,  304,  305,
  306,  307,  308,  256,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,   -1,  272,
  273,   -1,  275,  276,   -1,  278,   -1,  280,   -1,   -1,
  283,   -1,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
  303,  304,  305,  306,  307,  308,  256,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  264,  265,   -1,   -1,   -1,   -1,
   -1,   -1,  272,  273,   -1,  275,  276,   -1,  278,   -1,
  280,   -1,   -1,  283,   -1,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  256,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  264,  265,   -1,
   -1,  268,   -1,   -1,   -1,  272,   -1,   -1,  275,  276,
   -1,  278,   -1,  280,   -1,   -1,  283,   -1,  285,  286,
  287,  288,   -1,  290,  291,  292,  293,  294,  295,  296,
  297,  298,  299,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  260,   -1,   -1,   -1,  264,  265,   -1,   -1,
   -1,   -1,  270,   -1,  272,  273,   -1,  275,  276,   -1,
  278,   -1,  280,   -1,   -1,  283,   -1,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  262,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,  272,  273,   -1,  275,  276,   -1,  278,   -1,  280,
   -1,   -1,  283,   -1,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
  301,  302,  303,  304,  305,  306,  307,  308,  262,   -1,
  264,  265,   -1,  267,   -1,   -1,   -1,   -1,  272,  273,
   -1,  275,  276,   -1,  278,   -1,  280,   -1,   -1,  283,
   -1,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
  304,  305,  306,  307,  308,  262,   -1,  264,  265,   -1,
   -1,   -1,   -1,   -1,   -1,  272,  273,   -1,  275,  276,
   -1,  278,   -1,  280,   -1,   -1,  283,   -1,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
  297,  298,  299,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  264,  265,   -1,   -1,   -1,   -1,  270,   -1,
  272,  273,   -1,  275,  276,   -1,  278,   -1,  280,   -1,
   -1,  283,   -1,  285,  286,  287,  288,  289,  290,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
  302,  303,  304,  305,  306,  307,  308,  264,  265,   -1,
   -1,   -1,   -1,   -1,  271,  272,  273,   -1,  275,  276,
   -1,  278,   -1,  280,   -1,   -1,  283,   -1,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
  297,  298,  299,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  264,  265,   -1,   -1,   -1,   -1,   -1,   -1,
  272,  273,   -1,  275,  276,   -1,  278,   -1,  280,   -1,
   -1,  283,   -1,  285,  286,  287,  288,  289,  290,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
  302,  303,  304,  305,  306,  307,  308,  264,  265,   -1,
   -1,   -1,   -1,  270,   -1,  272,   -1,   -1,  275,  276,
   -1,  278,   -1,  280,   -1,   -1,  283,   -1,  285,  286,
  287,  288,   -1,  290,  291,  292,  293,  294,  295,  296,
  297,  298,  299,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  264,  265,   -1,   -1,  268,   -1,   -1,   -1,
  272,   -1,   -1,  275,  276,   -1,  278,   -1,  280,   -1,
   -1,  283,   -1,  285,  286,  287,  288,   -1,  290,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
  302,  303,  304,  305,  306,  307,  308,  264,  265,   -1,
   -1,   -1,   -1,   -1,   -1,  272,   -1,   -1,  275,  276,
   -1,  278,   -1,  280,   -1,   -1,  283,   -1,  285,  286,
  287,  288,   -1,  290,  291,  292,  293,  294,  295,  296,
  297,  298,  299,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  288,   -1,   -1,   -1,   -1,   -1,   -1,  256,
   -1,  258,   -1,  260,  261,   -1,  302,  303,  304,  305,
  306,  307,  308,  270,  271,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,
};
#define YYFINAL 40
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 308
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"STOP","CRLF","COLON","SEMICOL",
"COMMA","AT","DOT","MINUS","PLUS","PARLEFT","PARRIGHT","BRKLEFT","BRKRIGHT",
"LESSTHAN","GRTRTHAN","QUESTION","DEBENCOD","ENCODFIN","PUNCT","DATE","RDATE",
"FROM","SUBJECT","REPLYTO","INRPLYTO","RFERENCE","SENDER","MSGID","TO","CC",
"BCC","WORD","STRING","JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP",
"OCT","NOV","DEC","MON","TUE","WED","THU","FRI","SAT","SUN",
};
const char * const yyrule[] = {
"$accept : email",
"email : headers STOP",
"email : error STOP",
"headers : header",
"headers : headers header",
"header : data CRLF",
"data : originator",
"data : destination",
"data : dates",
"data : optionalfield",
"data : WORD",
"data : scrap",
"scrap : others",
"scrap : LESSTHAN",
"scrap : GRTRTHAN",
"scrap : error",
"originator : senders mailbox",
"senders : FROM COLON",
"senders : SENDER COLON",
"senders : REPLYTO COLON",
"destination : rcpts address",
"destination : bcc address",
"rcpts : TO COLON",
"rcpts : CC COLON",
"bcc : BCC COLON",
"optionalfield : hmsgid msgid",
"optionalfield : inrplyto mulids",
"optionalfield : references mulids",
"optionalfield : SUBJECT COLON",
"hmsgid : MSGID COLON",
"inrplyto : INRPLYTO COLON",
"references : RFERENCE COLON",
"mulids : msgids",
"mulids :",
"msgids : msgid",
"msgids : msgids msgid",
"msgid : LESSTHAN addrspec GRTRTHAN",
"msgid : LESSTHAN localpart GRTRTHAN",
"msgid : LESSTHAN GRTRTHAN",
"msgid : WORD",
"msgid : others",
"dates : origdate",
"dates : resentdate",
"origdate : DATE COLON datetime",
"resentdate : RDATE COLON datetime",
"datetime : days COMMA cachet",
"datetime : cachet",
"cachet : date time",
"cachet : date",
"date : integer months integer",
"time : hours zone",
"time : hours",
"time : zone",
"hours : hour COLON sixty COLON sixty",
"hours : hour COLON sixty",
"hour : integer",
"sixty : integer",
"zone : sign integer optime",
"zone : WORD",
"optime : PARLEFT comments PARRIGHT",
"optime :",
"comments : comment",
"comments : comments comment",
"comment : word",
"comment : AT",
"address : mailboxlist",
"address : group",
"address :",
"group : words COLON mailboxlist SEMICOL",
"group : words COLON SEMICOL",
"group : words COLON mailboxlist",
"mailboxlist : mailbox",
"mailboxlist : mailboxlist COMMA mailbox",
"mailbox : addrspec",
"mailbox : addrspec routeaddr",
"mailbox : routeaddr",
"mailbox : routeaddr words",
"mailbox : addrspec error",
"mailbox : words routeaddr",
"mailbox : words",
"addrspec : localpart AT domain",
"addrspec : localpart AT",
"localpart : words",
"localpart : localpart DOT words",
"localpart : localpart DOT error",
"localpart : localpart DOT error words",
"domain : subdomain",
"domain : domain DOT subdomain",
"domain : domain DOT error",
"subdomain : domainref",
"subdomain : domainliteral",
"domainref : atom",
"domainref : domainref atom",
"domainliteral : BRKLEFT words BRKRIGHT",
"routeaddr : LESSTHAN route addrspec GRTRTHAN",
"routeaddr : LESSTHAN addrspec GRTRTHAN",
"routeaddr : LESSTHAN GRTRTHAN",
"routeaddr : LESSTHAN words GRTRTHAN",
"route : AT domain COLON",
"words : word",
"words : words word",
"words : words error",
"word : atom",
"word : STRING",
"$$1 :",
"word : DEBENCOD $$1 ENCODFIN",
"integer : WORD",
"atom : WORD",
"atom : others",
"others : punctuation",
"others : marker",
"others : days",
"others : months",
"punctuation : PUNCT",
"punctuation : MINUS",
"punctuation : PLUS",
"punctuation : QUESTION",
"marker : DATE",
"marker : TO",
"marker : CC",
"marker : BCC",
"marker : FROM",
"marker : SENDER",
"marker : REPLYTO",
"months : JAN",
"months : FEB",
"months : MAR",
"months : APR",
"months : MAY",
"months : JUN",
"months : JUL",
"months : AUG",
"months : SEP",
"months : OCT",
"months : NOV",
"months : DEC",
"days : SUN",
"days : MON",
"days : TUE",
"days : WED",
"days : THU",
"days : FRI",
"days : SAT",
"sign : MINUS",
"sign : PLUS",
"sign : PLUS MINUS",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 1112 "geshdr.y"
#include	<memory.h>
#include	<ctype.h>
#include	<errno.h>

typedef	enum	{	/*email directive	*/
	mh_orgn,	/*E-mail physic origine	*/
	mh_from,	/*E-mail sender name	*/
	mh_rcpt,	/*E-mail recipient	*/
	mh_data		/*E-mail data phase	*/
	}MHTYP;

/*	Token list				*/
static struct	{
	int code;
	char *string;
	}vocable[]={	/*string MUST be in length order	*/
		   {INRPLYTO,	"In-Reply-To"},
		   {RDATE,	"Resent-Date"},
		   {MSGID,	"Message-ID"},
		   {RFERENCE,	"References"},
		   {REPLYTO,	"Reply-To"},
		   {SUBJECT,	"Subject"},
		   {SENDER,	"Sender"},
		   {DATE,	"Date"},
		   {FROM,	"From"},
		   {BCC,	"Bcc"},
		   {MON,"Mon"},{TUE,"Tue"},{WED,"Wed"},{THU,"Thu"},
		   {FRI,"Fri"},{SAT,"Sat"},{SUN,"Sun"},
		   {JAN,"Jan"},{FEB,"Feb"},{MAR,"Mar"},{APR,"Apr"},
		   {MAY,"May"},{JUN,"Jun"},{JUL,"Jul"},{AUG,"Aug"},
		   {SEP,"Sep"},{OCT,"Oct"},{NOV,"Nov"},{DEC,"Dec"},
		   {TO,		"To"},
		   {CC,		"Cc"},
		   {WORD,(char *)0}
		   };
/*

*/
/************************************************/
/*						*/
/*	Procedure to allocate a memory being	*/
/*	the contents of 2 memories, separated	*/
/*	by charactere (free the 2 previously	*/
/*	allocated memories)			*/
/*						*/
/************************************************/
static char *strmix(char *part1,char sep,char *part2)

{
char *mix;
int taille;

mix=(char *)0;
if (part1==(char *)0)
  part1=strdup("");
if (part2==(char *)0)
  part2=strdup("");
taille=strlen(part1)+strlen(part2)+2;
mix=(char *)calloc(1,taille);
if (sep!='\000') 
  (void) snprintf(mix,taille,"%s%c%s",part1,sep,part2);
else
  (void) snprintf(mix,taille,"%s%s",part1,part2);
(void) free(part2);
(void) free(part1);
return mix;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to report a parsing error	*/
/*	debugging mode only.			*/
/*						*/
/************************************************/
static void yyerror(char *info)

{
int dbg;

dbg=2;
if ((foreground==true)||(debug>=dbg)) {
  int i;
  char crlf[3];

  (void) strcpy(crlf,"");
  for (i=0;lines[curline][i]!='\000';i++)
    if (isspace(lines[curline][i])!=false)
      lines[curline][i]=' ';
  if (currow>=strlen(lines[curline]))
    (void) strcpy(crlf,"\\n");
  (void) tracing(LOG_DEBUG,dbg,"\n% 6d %.*s%s\n%*s %*s%s",
			      curline+1,currow+2,lines[curline],crlf,6,"",
			      currow+1,"^",info);
  }
nbrerr++;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to extract the punct char	*/
/*	value.					*/ 	
/*						*/
/************************************************/
static int punctchar(char c)

{
int code;

code=PUNCT;
switch (c) {
  case '\n'	:
    code=CRLF;
    break;
  case ':'	:
    code=COLON;
    break;
  case ';'	:
    code=SEMICOL;
    break;
  case ','	:
    code=COMMA;
    break;
  case '@'	:
    code=AT;
    break;
  case '.'	:
    code=DOT;
    break;
  case '-'	:
    code=MINUS;
    break;
  case '+'	:
    code=PLUS;
    break;
  case '('	:
    code=PARLEFT;
    break;
  case ')'	:
    code=PARRIGHT;
    break;
  case '['	:
    code=BRKLEFT;
    break;
  case ']'	:
    code=BRKRIGHT;
    break;
  case '<'	:
    code=LESSTHAN;
    break;
  case '>'	:
    code=GRTRTHAN;
    break;
  case '='	:
    code=PUNCT;
    if (numrow!=0) {
      if (lines[numline][numrow]=='?') {
        numrow++;
        code=DEBENCOD;
        }
      }
    break;
  case '?'	:
    code=QUESTION;
    if (numrow!=0) {
      if (lines[numline][numrow]=='=') {
        numrow++;
        code=ENCODFIN;
        }
      }
    break;
  default	:
    code=PUNCT;
    break;
  }
return code;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to extract the token value 	*/
/*	from a string				*/
/*						*/
/************************************************/
static int tokenfromstr(char *strtoken,int *disp)

{
int token;
int i;

*disp=0;
token=WORD;
for (i=0;vocable[i].string!=(char *)0;i++) {
  *disp=strlen(vocable[i].string);
  if (strncasecmp(vocable[i].string,strtoken,*disp)==0) {
    token=vocable[i].code;
    break;
    }
  }
return token;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to backspace in the header	*/
/*	the data-header				*/
/*						*/
/************************************************/
static void backspace()

{
numline=curline;
numrow=currow;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to get the next character from*/
/*	the data-header				*/
/*						*/
/************************************************/
static char getnextchar()

{
int c;

c=EOF;
if (lines[numline]!=(char *)0) {
  curline=numline;
  currow=numrow;
  if (numrow==0)
    (void) tracing(LOG_DEBUG,9,"%6d line=<%s>",numline+1,lines[numline]);
  c=(int)lines[numline][numrow];
  if (c=='\000') {
    c='\n';
    numrow=0;
    numline++;
    }
  else
    numrow++;
  }
return c;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to synchronize on  a special	*/
/*	character within the line parsed line.	*/
/*						*/
/************************************************/
static int skipfor(char expected)

{
int found;

found=false;
while (lines[numline][numrow]!='\000') {
  if (lines[numline][numrow]==expected) {
    found=true;
    break;
    }
  numrow++;
  }
return found;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to extract a string on a line	*/
/*						*/
/************************************************/
static char *getstring()

{
#define STRINC  20

char c;
char *strloc;
int locnumline;
int locnumrow;

locnumline=numline;
locnumrow=numrow;
strloc=(char *)calloc(1,STRINC+5);
while ((c=getnextchar())!=EOF) {
  int bspace;
  char ajout[2];

  bspace=false;
  if ((strlen(strloc)%STRINC)==0) {
    strloc=(char *)realloc(strloc,(((strlen(strloc)/STRINC)+1)*STRINC)+5);
    }
  bspace=((strlen(strloc)>1)&&(strloc[strlen(strloc)]=='\\'));
  if ((c=='\n')&&(bspace==false)) {
    (void) free(strloc);
    strloc=(char *)0;
    numline=locnumline;
    numrow=locnumrow;
    break;
    }
  if ((c=='\"')&&(bspace==false))
    break;
  ajout[0]=c;
  (void) strncat(strloc,ajout,1);
  }
return strloc;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to skip comment in the header	*/
/*						*/
/************************************************/
static int skipcomment()

{
int c;
int proceed;

proceed=true;
c='(';
while (proceed==true) {
  proceed=false;
  c=getnextchar();
  if (c=='(')
    c=skipcomment(); 
  switch(c) {
    case ')'	:
      c=getnextchar();
      break;
    case '\n'	:
    case EOF	:
      (void) yyerror("')' expected ");
      break;
    default	:
      proceed=true;
      break;
    }
  }
return c;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to skip all blank character	*/
/*						*/
/************************************************/
static int skipblank()

{
int c;
int proceed;

c=EOF;
proceed=true;
while (proceed==true) {
  c=getnextchar();
  while (c=='(') {
    c=skipcomment();
    }
  if (isblank(c)==false)
    proceed=false;
  }
return c;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to get/recognise a lexical	*/
/*	input.					*/
/*						*/
/************************************************/
static int yylex()

{
#define MXINFO	200

int found;
int c;
int proceed;
int phase;
int disp;
int numerique;
char info[MXINFO];

found=STOP;
phase=0;
proceed=true;
disp=0;
numerique=false;
(void) memset(info,'\000',sizeof(info));
c=skipblank();
if (c==EOF) {
  if (cptstop>0)
    (void) siglongjmp(manystop,1);
    cptstop++;
  return STOP;
  }
while (proceed==true) {
  switch (phase) {
    case     0	:	/*looking for strings	*/
      if (c=='\"') {
        if ((yylval.string=getstring())!=(char *)0) {
	  found=STRING;
	  proceed=false;
	  }
	}
      break;
    case     1	:	/* looking for punct	*/
      if (isalnum(c)==false) {
        found=punctchar(c);
	yylval.punct=(char)c;
	proceed=false;
	}
      break;
    case     2	:	/* looking for keyword	*/
      if ((found=tokenfromstr(lines[numline]+(numrow-1),&disp))!=WORD) {
	char *ptr;

	ptr=lines[numline]+(numrow-1)+disp;
	if (isalnum(*ptr)==false) {
	  numrow+=(disp-1);
	  proceed=false;
	  }
	}
      break;
    case     3	:	/*checking if word could be numeric	*/
      if (isdigit(c)!=false) 
	numerique=true;
      break;
    case     4	:	/*extracting word			*/
      {
      int extract;
      int inx;

      extract=true;
      inx=0;
      while (extract==true) {
        info[inx++]=c;
        if ((c=getnextchar())==EOF) {
          found=STOP;
	  if (cptstop>0)
	    (void) siglongjmp(manystop,1);
	  cptstop++;
	  extract=false;
	  break;
          }
        if (inx>=sizeof(info))
          extract=false;
        if (extract==false)
	  break;
        extract=((isalnum(c)!=false));
        if (numerique==true)
	  extract|=((c=='.')||(c=='-')||(c=='+'));
	}
      (void) backspace();
      }
      break;
    case     5	:	/* this an alphanumic word	*/
      yylval.word=strdup(info);
      found=WORD;
      proceed=false;
      break;
    default	:	/*safe guard			*/
      proceed=false;
      break;
    }
  phase++;
  }
#ifdef DEBUG
if (yydebug>0) {
  /*synchronizing yydebug output	*/
  (void) fflush(stdout);
  (void) fflush(stderr);
  }
#endif
if (debug>=11)
  (void) tracing(LOG_DEBUG,0,"return token (value='%d')",found);
return found;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to free the memory used by	*/
/*	a HDRTYP ** structure			*/
/*						*/
/************************************************/
static HDRTYP **cleanhdr(HDRTYP **chdrs)

{
if (chdrs!=(HDRTYP **)0) {
  int i;

  for (i=0;chdrs[i]!=(HDRTYP *)0;i++) {
    switch (chdrs[i]->field) {
      case (hd_from)		:
      case (hd_sender)		:
      case (hd_replyto)		:
      case (hd_msgid)		:
        if (chdrs[i]->info.address!=(char *)0)
          (void) free(chdrs[i]->info.address);
	break;
      case (hd_cc)		:
      case (hd_bcc)		:
      case (hd_to)		:
      case (hd_inreplyto)	:
      case (hd_references)	:
        if (chdrs[i]->info.maddr!=(char **)0) {
	  int j;

	  for (j=0;chdrs[i]->info.maddr[j]!=(char *)0;j++) {
	    (void) free(chdrs[i]->info.maddr[j]);
	    }
          (void) free(chdrs[i]->info.maddr);
	  }
	break;
      case (hd_date)		:
        if (chdrs[i]->info.time!=(char *)0)
          (void) free(chdrs[i]->info.time);
	break;
      case (hd_subject)		:
        if (chdrs[i]->info.subject!=(char *)0)
          (void) free(chdrs[i]->info.subject);
	break;
      default			:
        (void) tracing(LOG_DEBUG,0,"unievl.y,hdr_cleanhdr: Unexpected "
				   "field (bug?)");
	break;
      }
    (void) free(chdrs[i]);
    }
  (void) free(chdrs);
  chdrs=(HDRTYP **)0;
  }
return chdrs;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to trace the address part of	*/
/*	header contents				*/
/*						*/
/************************************************/
static void displayaddr(int lv,HDRTYP *hdr)

{
char *ptr;

switch(hdr->field) {
  case hd_to		:
    ptr="To";
    break;
  case hd_cc		:
    ptr="Cc";
    break;
  case hd_bcc		:
    ptr="Bcc";
    break;
  case hd_inreplyto	:
    ptr="In-Reply-To";
    break;
  case hd_references	:
    ptr="References";
    break;
  default		:
    ptr="(bug?)";
    break;
  }
if (hdr->info.maddr!=(char **)0) {
  int i;

  for (i=0;hdr->info.maddr[i]!=(char *)0;i++) 
    (void) tracing(LOG_DEBUG,lv,"E_%s: <%s>",ptr,hdr->info.maddr[i]);
  }
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to trace the wanted headers	*/
/*	contents, in the debug logs		*/
/*						*/
/************************************************/
static void tracehdr(int lv,HDRTYP **chdrs)

{
if (chdrs!=(HDRTYP **)0) {
  int i;

  for (i=0;chdrs[i]!=(HDRTYP *)0;i++) {
    switch (chdrs[i]->field) {
      case (hd_from)		:
	(void) tracing(LOG_DEBUG,lv,"E_From: <%s>",chdrs[i]->info.address);
	break;
      case (hd_cc)		:
      case (hd_bcc)		:
      case (hd_to)		:
      case (hd_inreplyto)	:
      case (hd_references)	:
	(void) displayaddr(lv,chdrs[i]);
	break;
      case (hd_sender)		:
	(void) tracing(LOG_DEBUG,lv,"E_Sender: <%s>",chdrs[i]->info.address);
	break;
      case (hd_replyto)		:
	(void) tracing(LOG_DEBUG,lv,"E_Reply-To: <%s>",chdrs[i]->info.address);
	break;
      case (hd_msgid)		:
	(void) tracing(LOG_DEBUG,lv,"E_Message-ID: <%s>",chdrs[i]->info.address);
	break;
      case (hd_date)		:
	{
	char *ptr;
	time_t temps;

	temps=atol(chdrs[i]->info.time);	
	ptr=asctime(gmtime(&temps));
	ptr[strlen(ptr)-1]='\000';
	(void) tracing(LOG_DEBUG,lv,"E_Date: <%s>",ptr);
	}
	break;
      case (hd_subject)		:
	(void) tracing(LOG_DEBUG,lv,"E_Subject: <%s>",chdrs[i]->info.subject);
	break;
      default			:
        (void) tracing(LOG_DEBUG,0,"unievl.c,evl_tracehdr: Unexpected "
				   "field (bug?)");
	break;
      }
    }
  }
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to scan a header and locate	*/
/*	specific information			*/
/*						*/
/************************************************/
static HDRTYP **mkhdr(char **data)

{
int verybad;

verybad=false;
cptstop=0;
ghdrs=(HDRTYP **)0;
lines=data;
numline=0;
numrow=0;
itsok=true;
nbrerr=0;
#ifdef DEBUG
if (debug>11)	/*debugging all yacc analyze	*/
  yydebug=1;
#endif
if (sigsetjmp(manystop,true)==0)
  verybad=yyparse(); 
else {
  verybad=true;
  }
if (verybad==true)
  ghdrs=cleanhdr(ghdrs); 
/*to fully clean yyparse used memory		*/
/*
if (yyvs!=(YYSTYPE *)0) {
  (void) free(yyvs);
  yyvs=(YYSTYPE *)0;
  }
if (yyss!=(short *)0) {
  (void) free(yyss);
  yyss=(short *)0;
  }
*/
return ghdrs;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to extract a reference found	*/
/*	available in the E-mail header.		*/
/*						*/
/************************************************/
static void *gethdrinfo(HDRTYP **hdrs,HIDTYP field)


{
void *str;

str=(char *)0;
if (hdrs!=(HDRTYP **)0) {
  int i;

  for (i=0;hdrs[i]!=(HDRTYP *)0;i++) {
    if (hdrs[i]->field==field) {
      switch (field) {
        case (hd_from)		:
        case (hd_sender)	:
        case (hd_replyto)	:
        case (hd_msgid)		:
          str=(void *)hdrs[i]->info.address;
	  break;
  	case (hd_date)		:
          str=(void *)hdrs[i]->info.time;
	  break;
  	case (hd_inreplyto)	:
  	case (hd_references)	:
          str=(void *)hdrs[i]->info.maddr;
	  break;
  	case (hd_to)		:
  	case (hd_cc)		:
  	case (hd_bcc)		:
          str=(void *)hdrs[i]->info.maddr;
	  break;
        case (hd_subject)	:
          str=(void *)hdrs[i]->info.subject;
	  break;
  	default			:
    	  (void) tracing(LOG_DEBUG,0,"unievl.c,evl_genheader: Unexpected "
				     "field (bug?)");
	  break;
	}
      break;
      }
    }
  }
return str;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to collect specific set of	*/
/*	headers.				*/
/*						*/
/************************************************/
static char **mklist(HDRTYP **hdrs,char **list,HIDTYP hid)

{
char **mptr;

if ((mptr=gethdrinfo(hdrs,hid))!=(char **)0) {
  int i;

  for (i=0;mptr[i]!=(char *)0;i++) {
    list=(char **)rou_addveclst((void **)list,(void *)strdup(mptr[i]));
    }
  }
return list;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to normalize some E-mails	*/
/*	(generated by mailling list) such	*/
/*	address x.12.34@somewhere.com		*/
/*	is translated to x@somewhwere.com	*/
/*						*/
/************************************************/
static char *cleanreal(char *real)

{
if (real!=(char *)0) {
  char *ptr;

  if ((ptr=strchr(real,'.'))!=(char *)0) {
    char *dotptr;
    int skip;
    int proceed;

    dotptr=ptr;
    ptr++;
    skip=true;
    proceed=true;
    while (proceed==true) {
      switch (*ptr) {
        case '@'  	:
        case '\000'  	:
	  proceed=false;	/*do NOT break	*/
        case '.'	:
	  if (skip==true) {
	    (void) strcpy(dotptr,ptr);
	    ptr=dotptr;
	    }
	  dotptr=ptr;
	  skip=true;
	  break;
	default		:
	  if (skip==true)
	    skip=(isdigit(*ptr)!=false);
	  break;
        }
      ptr++;
      }
    }
  }
return real;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to look at E-mail header	*/
/*	information and extract selected fields	*/
/*						*/
/************************************************/
static EVLTYP *lookhdrs(HDRTYP **hdrs)

{
int phase;
int proceed;
EVLTYP *evl;

proceed=true;
phase=1;	/*phase 0 is the exist phase	*/
evl=(EVLTYP *)calloc(1,sizeof(EVLTYP));
while (proceed==true) {
  char *ptr;

  ptr=(char *)0;
  switch (phase) {
    case	 0  :
      proceed=false;
      break;
    case	 1  :	/*extracting "Sender"	*/
      if ((ptr=gethdrinfo(hdrs,hd_sender))!=(char *)0) {
	evl->org=org_sender;
        evl->realfrom=strdup(ptr);
	phase+=2;	/*getting MSG DATE	*/
        }
      break;
    case	 2  :	/*extracting "Reply-To"	*/
      if ((ptr=gethdrinfo(hdrs,hd_replyto))!=(char *)0) {
	evl->org=org_replyto;
        evl->realfrom=strdup(ptr);
	phase+=1;	/*getting MSG DATE	*/
        }
      break;
    case	 3  :	/*extracting "From"	*/
      if ((ptr=gethdrinfo(hdrs,hd_from))!=(char *)0) {
	evl->org=org_from;
        evl->realfrom=strdup(ptr);
        }
      break;
    case	 4  :	/*empty phase 		*/
      break;
    case	 5  :	/*extracting MSG date	*/
      if ((ptr=gethdrinfo(hdrs,hd_date))!=(char *)0) {
        evl->cachet=(time_t)atol(ptr);
        }
      break;
    case	 6  :	/*extracting MSGID	*/
      if ((ptr=gethdrinfo(hdrs,hd_msgid))!=(char *)0) {
        evl->msgid=strdup(ptr);
	}
      break;
    case	 7  :	/*extracting Subject	*/
      if ((ptr=gethdrinfo(hdrs,hd_subject))!=(char *)0) {
        evl->subject=strdup(ptr);
	}
      break;
    case	 8  :	/*extracting In-Reply-To*/
      evl->inrplyto=mklist(hdrs,(char **)0,hd_inreplyto);
      evl->inrplyto=mklist(hdrs,evl->inrplyto,hd_references);
      break;
    case	 9  :	/*extracting To,Cc,Bcc	*/
      evl->distlist=mklist(hdrs,(char **)0,hd_to);
      evl->distlist=mklist(hdrs,evl->distlist,hd_cc);
      evl->distlist=mklist(hdrs,evl->distlist,hd_bcc);
      break;
    case	10  :	/*cleaning realfrom	*/
      evl->realfrom=cleanreal(evl->realfrom); 
      break;
    default	    :	/*fail safe		*/
      phase=-1;		/*going to the exit	*/
      break;
    }
  phase++;
  }
return evl;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to build a E-mail header	*/
/*	list, by concatanating lines which start*/
/*	with a space (see RFC 2022)		*/
/*						*/
/************************************************/
char **mkyachdr(char **headers)

{
char **yachdr;

yachdr=(char **)0;
if (headers!=(char **)0) {
  int i;

  for (i=0;headers[i]!=(char *)0;i++) {
    char *ptr;

    ptr=strdup(headers[i]);
    while (headers[i+1]!=(char *)0) {
      if (isblank(headers[i+1][0])==0)
	break;
      i++;
      ptr=(char *)realloc(ptr,strlen(ptr)+strlen(headers[i])+4);
      (void) strcat(ptr,headers[i]);
      }
    yachdr=(char **)rou_addveclst((void **)yachdr,(void *)ptr);
    }
  }
return yachdr;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to analyse the email header	*/
/*	part. looking for information as:	*/
/*	Sender:, Reply-To:, From:...		*/
/*						*/
/************************************************/
EVLTYP *hdr_parseheader(char **headers)

{
EVLTYP *evl;

evl=(EVLTYP *)0;
if (headers!=(char **)0) {
  HDRTYP **hdrs;
  char **yachdr;

  yachdr=mkyachdr(headers);
  if ((hdrs=mkhdr(yachdr))!=(HDRTYP **)0) {
    evl=lookhdrs(hdrs);
    evl->nbrerror=nbrerr;
    if (debug>=2)
      (void) tracehdr(2,hdrs);
    hdrs=cleanhdr(hdrs);
    }
  else {
    (void) alert(0,"geshdr.y:hdr_parsehdr, fatal header parsing error");
    (void) journalling(true,APJRL,"fatal header parsing error!");
    }
  (void) rou_freestrlst(yachdr);
  }
return evl;
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to free memory used by an	*/
/*	E-mail info structure			*/
/*						*/
/************************************************/
EVLTYP *hdr_freeevl(EVLTYP *evl)

{
if (evl!=(EVLTYP *)0) {
  evl->spamlvl=rou_freestr(evl->spamlvl);
  evl->virname=rou_freestr(evl->virname);
  evl->distlist=rou_freestrlst(evl->distlist);
  evl->inrplyto=rou_freestrlst(evl->inrplyto);
  evl->msgid=rou_freestr(evl->msgid);
  evl->subject=rou_freestr(evl->subject);
  evl->realfrom=rou_freestr(evl->realfrom);
  (void) free(evl);
  evl=(EVLTYP *)0;
  }
return evl;
}
#line 1750 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 213 "geshdr.y"
{
			ghdrs=yyvsp[-1].hdrs;
                        if (itsok==true)
                          YYACCEPT;
                        else
                          YYABORT;
			}
break;
case 2:
#line 221 "geshdr.y"
{
			YYABORT;
			}
break;
case 3:
#line 227 "geshdr.y"
{
			yyval.hdrs=addhdrs((HDRTYP **)0,yyvsp[0].header);
			ghdrs=yyval.hdrs;
			}
break;
case 4:
#line 232 "geshdr.y"
{
			yyval.hdrs=addhdrs(yyvsp[-1].hdrs,yyvsp[0].header);
			ghdrs=yyval.hdrs;
			}
break;
case 5:
#line 239 "geshdr.y"
{
			yyval.header=yyvsp[-1].header;
			}
break;
case 6:
#line 245 "geshdr.y"
{
			yyval.header=yyvsp[0].header;
			}
break;
case 7:
#line 249 "geshdr.y"
{
			yyval.header=yyvsp[0].header;
			}
break;
case 8:
#line 253 "geshdr.y"
{
			yyval.header=yyvsp[0].header;
			}
break;
case 9:
#line 257 "geshdr.y"
{
			yyval.header=yyvsp[0].header;
			}
break;
case 10:
#line 261 "geshdr.y"
{
			(void) free(yyvsp[0].word);
			yyval.header=(HDRTYP *)0;
			if (numrow>0)
			  while (lines[numline][numrow]!='\000')
			     numrow++;
			}
break;
case 11:
#line 269 "geshdr.y"
{
			yyval.header=(HDRTYP *)0;
			if (numrow>0)
			  while (lines[numline][numrow]!='\000')
			     numrow++;
			(void) tracing(LOG_DEBUG,2,"header error!");
			}
break;
case 12:
#line 279 "geshdr.y"
{
			if (yyvsp[0].word!=(char *)0)
			  (void) free(yyvsp[0].word);
			}
break;
case 16:
#line 294 "geshdr.y"
{
			yyval.header=(HDRTYP *)0;
			if (yyvsp[0].email!=(char *)0)
			  yyval.header=genheader(yyvsp[-1].integer,yyvsp[0].generic);
			}
break;
case 17:
#line 302 "geshdr.y"
{
			yyval.integer=(int)hd_from;
			}
break;
case 18:
#line 306 "geshdr.y"
{
			yyval.integer=(int)hd_sender;
			}
break;
case 19:
#line 310 "geshdr.y"
{
			yyval.integer=(int)hd_replyto;
			}
break;
case 20:
#line 316 "geshdr.y"
{
			yyval.header=(HDRTYP *)0;
			if (yyvsp[0].mboxes!=(char **)0)
			  yyval.header=genheader(yyvsp[-1].integer,yyvsp[0].generic);
			}
break;
case 21:
#line 322 "geshdr.y"
{
			yyval.header=(HDRTYP *)0;
			if (yyvsp[0].mboxes!=(char **)0)
			  yyval.header=genheader(yyvsp[-1].integer,yyvsp[0].generic);
			}
break;
case 22:
#line 330 "geshdr.y"
{
			yyval.integer=(int)hd_to;
			}
break;
case 23:
#line 334 "geshdr.y"
{
			yyval.integer=(int)hd_cc;
			}
break;
case 24:
#line 340 "geshdr.y"
{
			yyval.integer=(int)hd_bcc;
			}
break;
case 25:
#line 346 "geshdr.y"
{
			yyval.header=(HDRTYP *)0;
			if (yyvsp[0].mboxes!=(char **)0)
			  yyval.header=genheader(yyvsp[-1].integer,yyvsp[0].generic);
			}
break;
case 26:
#line 352 "geshdr.y"
{
			yyval.header=(HDRTYP *)0;
			if (yyvsp[0].mboxes!=(char **)0)
			  yyval.header=genheader(yyvsp[-1].integer,yyvsp[0].generic);
			}
break;
case 27:
#line 358 "geshdr.y"
{
			yyval.header=(HDRTYP *)0;
			if (yyvsp[0].mboxes!=(char **)0)
			  yyval.header=genheader(yyvsp[-1].integer,yyvsp[0].generic);
			}
break;
case 28:
#line 364 "geshdr.y"
{
			#define MXSUB	120

			int i;
			char *ptr;

			ptr=strdup(&(lines[numline][numrow]));
			if (strlen(ptr)>MXSUB)
			  ptr[MXSUB]='\000';
			for (i=0;ptr[i]!='\000';i++)
			  if (ptr[i]<' ')
			    ptr[i]=' ';
			while (ptr[0]==' ')
			  (void) strcpy(ptr,ptr+1);
			yyval.header=genheader((int)hd_subject,(void *)ptr);
			if (lines[numline]!=(char *)0) {
			  while (lines[numline][numrow]!='\000')
			     numrow++;
			  }
			}
break;
case 29:
#line 388 "geshdr.y"
{
			yyval.integer=(int)hd_msgid;
			}
break;
case 30:
#line 394 "geshdr.y"
{
			yyval.integer=(int)hd_inreplyto;
			}
break;
case 31:
#line 400 "geshdr.y"
{
			yyval.integer=(int)hd_references;
			}
break;
case 32:
#line 406 "geshdr.y"
{
			yyval.mboxes=yyvsp[0].mboxes;
			}
break;
case 33:
#line 410 "geshdr.y"
{
			yyval.mboxes=(char **)0;
			}
break;
case 34:
#line 416 "geshdr.y"
{
			yyval.mboxes=(char **)0;
			if (yyvsp[0].email!=(char *)0)
  			  yyval.mboxes=(char **)rou_addveclst((void **)0,
						           (void *)yyvsp[0].email);
			}
break;
case 35:
#line 423 "geshdr.y"
{
			yyval.mboxes=yyvsp[-1].mboxes;
			if (yyvsp[0].email!=(char *)0)
  			  yyval.mboxes=(char **)rou_addveclst((void **)yyvsp[-1].mboxes,
						           (void *)yyvsp[0].email);
			}
break;
case 36:
#line 432 "geshdr.y"
{
			yyval.email=yyvsp[-1].email;
			(void) rou_strtolower(yyval.email); 
			(void) skipfor('<');
			}
break;
case 37:
#line 438 "geshdr.y"
{
			if (yyvsp[-1].email!=(char *)0) {
			  (void) free(yyvsp[-1].email);
			  yyvsp[-1].email=(char *)0;
			  }
			yyval.email=yyvsp[-1].email;
			(void) rou_strtolower(yyval.email); 
			(void) skipfor('<');
			}
break;
case 38:
#line 448 "geshdr.y"
{
			yyval.email=(char *)0;
			(void) skipfor('<');
			}
break;
case 39:
#line 453 "geshdr.y"
{
			if (yyvsp[0].word!=(char *)0)
			  (void) free(yyvsp[0].word);
			yyval.email=(char *)0;
			(void) skipfor('<');
			}
break;
case 40:
#line 460 "geshdr.y"
{
			if (yyvsp[0].word!=(char *)0)
			  (void) free(yyvsp[0].word);
			yyval.email=(char *)0;
			(void) skipfor('<');
			}
break;
case 41:
#line 475 "geshdr.y"
{
			yyval.header=yyvsp[0].header;
			}
break;
case 42:
#line 479 "geshdr.y"
{
			yyval.header=yyvsp[0].header;
			}
break;
case 43:
#line 485 "geshdr.y"
{
			yyval.header=genheader(hd_date,yyvsp[0].strtime);
			}
break;
case 44:
#line 492 "geshdr.y"
{
			yyval.header=genheader(hd_date,yyvsp[0].strtime);
			}
break;
case 45:
#line 498 "geshdr.y"
{
			yyval.strtime=yyvsp[0].strtime;
			}
break;
case 46:
#line 502 "geshdr.y"
{
			yyval.strtime=yyvsp[0].strtime;
			}
break;
case 47:
#line 508 "geshdr.y"
{
			yyval.strtime=(char *)calloc(1,20);	
			(void) sprintf(yyval.strtime,"%ld",yyvsp[-1].integer+yyvsp[0].integer);
			}
break;
case 48:
#line 513 "geshdr.y"
{
			yyval.strtime=(char *)calloc(1,20);	
			(void) sprintf(yyval.strtime,"%ld",yyvsp[0].integer);
			}
break;
case 49:
#line 520 "geshdr.y"
{
			struct tm timing;

			(void) memset(&timing,'\000',sizeof(timing));
			timing.tm_mday=yyvsp[-2].integer;
			timing.tm_mon=yyvsp[-1].integer;
	 		if (yyvsp[0].integer<100)
			  yyvsp[0].integer+=2000;
			timing.tm_year=yyvsp[0].integer-1900;
			yyval.time=timegm(&timing);
			}
break;
case 50:
#line 534 "geshdr.y"
{
			yyval.time=yyvsp[-1].time-yyvsp[0].time;
			}
break;
case 51:
#line 538 "geshdr.y"
{
			yyval.time=yyvsp[0].time;
			}
break;
case 52:
#line 542 "geshdr.y"
{
			yyval.time=-yyvsp[0].time;
			}
break;
case 53:
#line 548 "geshdr.y"
{
			yyval.time=(((yyvsp[-4].time*60)+(yyvsp[-2].time))*60)+yyvsp[0].time;
			}
break;
case 54:
#line 552 "geshdr.y"
{
			yyval.time=((yyvsp[-2].time*60)+(yyvsp[0].time))*60;
			}
break;
case 55:
#line 558 "geshdr.y"
{
			yyval.time=yyvsp[0].integer;
			if (yyvsp[0].integer>24) {
			  (void) yyerror("Unexpected value (above 24 Hour)");
			  yyval.time=0;
			  } 
			}
break;
case 56:
#line 568 "geshdr.y"
{
			yyval.time=yyvsp[0].integer;
			if (yyvsp[0].integer>60) {
			  (void) yyerror("Unexpected value (above 60)");
			  yyval.time=0;
			  } 
			}
break;
case 57:
#line 578 "geshdr.y"
{
			yyval.time=((yyvsp[-1].integer/100)*3600)+((yyvsp[-1].integer%100)*60);
			yyval.time*=yyvsp[-2].integer;
			}
break;
case 58:
#line 583 "geshdr.y"
{
			static struct {
				char *zname;
				int diff;
				}tznom[]={
					  {"UTC",-0},
					  {"Z",-0},
					  {"GMT",-0},
					  {"EST",-5},
					  {"EDT",-4},
					  {"CST",-6},
					  {"CDT",-5},
					  {"MST",-7},
					  {"MDT",-6},
					  {"PST",-8},
					  {"PDT",-7},
					  {"AKST",-9},
					  {"AKDT",-8},
					  {"HST",-10},
					  {"HST",-10},
					  {"BST",+1},
					  {"CET",+1},
					  {"CST",+2},
					  {(char *)0,0}
					  };
			int i;

			yyval.time=0;
			for (i=0;tznom[i].zname!=(char *)0;i++) {
			  if (strcasecmp(tznom[i].zname,yyvsp[0].word)==0) {
			    yyval.time=tznom[i].diff*3600;
			    break;
			    }
			  }	
			(void) free(yyvsp[0].word);
			}
break;
case 63:
#line 631 "geshdr.y"
{
			(void) free(yyvsp[0].word);
			}
break;
case 65:
#line 643 "geshdr.y"
{
			yyval.mboxes=yyvsp[0].mboxes;
			}
break;
case 66:
#line 647 "geshdr.y"
{
			yyval.mboxes=yyvsp[0].mboxes;
			}
break;
case 67:
#line 651 "geshdr.y"
{
			yyval.mboxes=(char **)0;
			}
break;
case 68:
#line 657 "geshdr.y"
{
			if (yyvsp[-3].word!=(char *)0)
			  (void) free(yyvsp[-3].word);
			yyval.mboxes=yyvsp[-1].mboxes;
			}
break;
case 69:
#line 663 "geshdr.y"
{
			if (yyvsp[-2].word!=(char *)0)
			  (void) free(yyvsp[-2].word);
			yyval.mboxes=(char **)0;
			}
break;
case 70:
#line 669 "geshdr.y"
{
			if (yyvsp[-2].word!=(char *)0)
			  (void) free(yyvsp[-2].word);
			yyval.mboxes=yyvsp[0].mboxes;
			}
break;
case 71:
#line 677 "geshdr.y"
{
			yyval.mboxes=(char **)0;
			if (yyvsp[0].email!=(char *)0) {
			  (void) rou_strtolower(yyvsp[0].email);
  			  yyval.mboxes=(char **)rou_addveclst((void **)0,
						           (void *)yyvsp[0].email);
			  }
			}
break;
case 72:
#line 686 "geshdr.y"
{
			yyval.mboxes=yyvsp[-2].mboxes;
			if (yyvsp[-2].email!=(char *)0) {
			  (void) rou_strtolower(yyvsp[0].email);
  			  yyval.mboxes=(char **)rou_addveclst((void **)yyvsp[-2].mboxes,
						           (void *)yyvsp[0].email);
			  }
			}
break;
case 73:
#line 697 "geshdr.y"
{
			yyval.email=yyvsp[0].email;
			}
break;
case 74:
#line 701 "geshdr.y"
{
			if (yyvsp[-1].email!=(char *)0)
			  (void) free(yyvsp[-1].email);
			yyval.email=yyvsp[0].email;
			}
break;
case 75:
#line 707 "geshdr.y"
{
			/*trapping common syntax error	*/
			yyval.email=yyvsp[0].email;
			}
break;
case 76:
#line 712 "geshdr.y"
{
			/*trapping common syntax error	*/
			if (yyvsp[0].email!=(char *)0)
			  (void) free(yyvsp[0].email);
			yyval.email=yyvsp[-1].email;
			}
break;
case 77:
#line 719 "geshdr.y"
{
			yyval.email=yyvsp[-1].email;
			}
break;
case 78:
#line 723 "geshdr.y"
{
			if (yyvsp[-1].email!=(char *)0)
			  (void) free(yyvsp[-1].email);
			yyval.email=yyvsp[0].email;
			}
break;
case 79:
#line 729 "geshdr.y"
{
			if (yyvsp[0].email!=(char *)0)
			  (void) free(yyvsp[0].email);
			yyval.email=(char *)0;
			}
break;
case 80:
#line 737 "geshdr.y"
{
			char *strloc;

			strloc=strmix(yyvsp[-2].email,'@',yyvsp[0].email);
			(void) rou_strtolower(strloc);
			yyval.email=strloc;
			}
break;
case 81:
#line 746 "geshdr.y"
{
			if (yyvsp[-1].word!=(char *)0)
			  (void) free(yyvsp[-1].word);
			yyval.word=(char *)0;
			}
break;
case 82:
#line 754 "geshdr.y"
{
			yyval.email=yyvsp[0].email;
			}
break;
case 83:
#line 758 "geshdr.y"
{
			yyval.email=strmix(yyvsp[-2].email,'.',yyvsp[0].word);
			}
break;
case 84:
#line 762 "geshdr.y"
{
			yyval.email=yyvsp[-2].email;
			}
break;
case 85:
#line 766 "geshdr.y"
{
			if (yyvsp[0].word!=(char *)0) {
			  (void) free(yyvsp[0].word);
			  }
			yyval.email=yyvsp[-3].email;
			}
break;
case 86:
#line 775 "geshdr.y"
{
			yyval.email=yyvsp[0].email;
			}
break;
case 87:
#line 779 "geshdr.y"
{
			yyval.email=strmix(yyvsp[-2].email,'.',yyvsp[0].email);
			}
break;
case 88:
#line 783 "geshdr.y"
{
			yyval.email=yyvsp[-2].email;
			}
break;
case 89:
#line 789 "geshdr.y"
{
			yyval.email=yyvsp[0].email;
			}
break;
case 90:
#line 793 "geshdr.y"
{
			yyval.email=yyvsp[0].email;
			}
break;
case 91:
#line 799 "geshdr.y"
{
			yyval.email=yyvsp[0].word;
			}
break;
case 92:
#line 803 "geshdr.y"
{
			yyval.email=strmix(yyvsp[-1].email,'\000',yyvsp[0].word);
			}
break;
case 93:
#line 809 "geshdr.y"
{
			yyval.email=(char *)0;
			if (yyvsp[-1].word!=(char *)0) {
			  yyval.email=(char *)calloc(1,strlen(yyvsp[-1].word)+4);
			  (void) strcpy(yyval.email,"[");
			  (void) strcat(yyval.email,yyvsp[-1].word);
			  (void) strcat(yyval.email,"]");
			  (void) free(yyvsp[-1].word);
			  }
			}
break;
case 94:
#line 822 "geshdr.y"
{
			yyval.email=yyvsp[-1].email;
			}
break;
case 95:
#line 826 "geshdr.y"
{
			yyval.email=yyvsp[-1].email;
			}
break;
case 96:
#line 830 "geshdr.y"
{
			yyval.email=(char *)0;
			}
break;
case 97:
#line 834 "geshdr.y"
{
			if (yyvsp[-1].word!=(char *)0)
			  (void) free(yyvsp[-1].word);
			nbrerr++;
			yyval.email=(char *)0;
			}
break;
case 98:
#line 843 "geshdr.y"
{
			if (yyvsp[-1].email!=(char *)0)
			  (void) free(yyvsp[-1].word);
			}
break;
case 99:
#line 853 "geshdr.y"
{
			yyval.word=yyvsp[0].word;
			}
break;
case 100:
#line 857 "geshdr.y"
{
			yyval.word=strmix(yyvsp[-1].word,'\000',yyvsp[0].word);
			}
break;
case 101:
#line 861 "geshdr.y"
{
			if (yyvsp[-1].word!=(char *)0) {
			  (void) free(yyvsp[-1].word);
			  }
			yyval.word=(char *)0;
			}
break;
case 102:
#line 870 "geshdr.y"
{
			yyval.word=yyvsp[0].word;
			}
break;
case 103:
#line 874 "geshdr.y"
{
			yyval.word=yyvsp[0].word;
			}
break;
case 104:
#line 878 "geshdr.y"
{	/*WAITING for end of encoding	*/
			int phase;
			int proceed;

			phase=0;
			proceed=true;
			while (skipfor('?')==true) {
			  switch (phase) {
			    case 0  :
			    case 1  :
			      phase++;
			      break;
			    case 2  :
			      if (lines[numline][numrow+1]!='=') {
			        nbrerr++;
			        (void) yyerror("Encoding syntax error");
				}
			      proceed=false;
			      break;
			    }
			  if (proceed==true)
			    numrow+=1;
			  else
			    break;
			  }
			}
break;
case 105:
#line 905 "geshdr.y"
{
			yyval.word=(char *)0;
			}
break;
case 106:
#line 911 "geshdr.y"
{
			char *ptr;

			ptr=yyvsp[0].word;
			yyval.integer=0;
        		if (strchr(ptr,'.')==(char *)0) {
			  long lval;

          		  if (sscanf(ptr,"%ld",&lval)==1) {
            		    yyval.integer=lval;
            		    }
          		  }
        		else {
			  (void) yyerror("Integer expected, found float");
			  }
			(void) free(yyvsp[0].word);
			}
break;
case 107:
#line 931 "geshdr.y"
{
			yyval.word=yyvsp[0].word;
			}
break;
case 108:
#line 935 "geshdr.y"
{
			yyval.word=yyvsp[0].word;
			}
break;
case 109:
#line 942 "geshdr.y"
{
			yyval.word=yyvsp[0].word;
			}
break;
case 110:
#line 946 "geshdr.y"
{
			yyval.word=yyvsp[0].word;
			}
break;
case 111:
#line 950 "geshdr.y"
{
		        static char *daylist[]={
		   		"Sun","Mon","Tue","Wed","Thu",
		   		"Fri","Sat"};
			yyval.word=strdup(daylist[yyvsp[0].integer]);
			}
break;
case 112:
#line 957 "geshdr.y"
{
		        static char *monthlist[]={
				"Jan","Feb","Mar","Apr",
				"May","Jun","Jul","Aug",
		   		"Sep","Oct","Nov","Dec"};
			yyval.word=strdup(monthlist[yyvsp[0].integer]);
			}
break;
case 113:
#line 967 "geshdr.y"
{
			char strloc[10];

			(void) memset(strloc,'\000',sizeof(strloc));
			strloc[0]=yyvsp[0].punct;
			yyval.word=strdup(strloc);
			}
break;
case 114:
#line 975 "geshdr.y"
{
			yyval.word=strdup("-");
			}
break;
case 115:
#line 979 "geshdr.y"
{
			yyval.word=strdup("+");
			}
break;
case 116:
#line 983 "geshdr.y"
{
			yyval.word=strdup("?");
			}
break;
case 117:
#line 989 "geshdr.y"
{
			yyval.word=strdup("Date");
			}
break;
case 118:
#line 993 "geshdr.y"
{
			yyval.word=strdup("To");
			}
break;
case 119:
#line 997 "geshdr.y"
{
			yyval.word=strdup("Cc");
			}
break;
case 120:
#line 1001 "geshdr.y"
{
			yyval.word=strdup("Bcc");
			}
break;
case 121:
#line 1005 "geshdr.y"
{
			yyval.word=strdup("From");
			}
break;
case 122:
#line 1009 "geshdr.y"
{
			yyval.word=strdup("Sender");
			}
break;
case 123:
#line 1013 "geshdr.y"
{
			yyval.word=strdup("Reply-To");
			}
break;
case 124:
#line 1019 "geshdr.y"
{
			yyval.integer=0;
			}
break;
case 125:
#line 1023 "geshdr.y"
{
			yyval.integer=1;
			}
break;
case 126:
#line 1027 "geshdr.y"
{
			yyval.integer=2;
			}
break;
case 127:
#line 1031 "geshdr.y"
{
			yyval.integer=3;
			}
break;
case 128:
#line 1035 "geshdr.y"
{
			yyval.integer=4;
			}
break;
case 129:
#line 1039 "geshdr.y"
{
			yyval.integer=5;
			}
break;
case 130:
#line 1043 "geshdr.y"
{
			yyval.integer=6;
			}
break;
case 131:
#line 1047 "geshdr.y"
{
			yyval.integer=7;
			}
break;
case 132:
#line 1051 "geshdr.y"
{
			yyval.integer=8;
			}
break;
case 133:
#line 1055 "geshdr.y"
{
			yyval.integer=9;
			}
break;
case 134:
#line 1059 "geshdr.y"
{
			yyval.integer=10;
			}
break;
case 135:
#line 1063 "geshdr.y"
{
			yyval.integer=11;
			}
break;
case 136:
#line 1069 "geshdr.y"
{
			yyval.integer=0;
			}
break;
case 137:
#line 1073 "geshdr.y"
{
			yyval.integer=1;
			}
break;
case 138:
#line 1077 "geshdr.y"
{
			yyval.integer=2;
			}
break;
case 139:
#line 1081 "geshdr.y"
{
			yyval.integer=3;
			}
break;
case 140:
#line 1085 "geshdr.y"
{
			yyval.integer=4;
			}
break;
case 141:
#line 1089 "geshdr.y"
{
			yyval.integer=5;
			}
break;
case 142:
#line 1093 "geshdr.y"
{
			yyval.integer=6;
			}
break;
case 143:
#line 1099 "geshdr.y"
{
			yyval.integer=-1;
			}
break;
case 144:
#line 1103 "geshdr.y"
{
			yyval.integer=+1;
			}
break;
case 145:
#line 1107 "geshdr.y"
{
			yyval.integer=+1;
			}
break;
#line 2981 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
