/************************************************/
/*						*/
/*      Copyright:				*/
/*		 Jean-Marc Pigeon <jmp@safe.ca>	*/
/*	Distributed under the Gnu Public	*/
/*	License, see the License file in this	*/
/*	package.				*/
/*						*/
/*	Define routine to manage a TSL 		*/
/*	(uncrypted/crypted) channel.		*/
/*						*/
/************************************************/
#ifndef GESTLS
#define GESTLS
#include	"unidev.h"

typedef void TLSFILE;

extern int tls_getfeed(TLSFILE *tlsfile);
extern int tls_write(TLSFILE *tls,char *buffer,int parnum);
extern TLSFILE *tls_accept(LSTTYP *lst);
extern int tls_gotls(TLSFILE *tls,int accepting);
extern char *tls_getcipher(TLSFILE *tls);
extern int tls_close(TLSFILE *tls);
extern int tls_printf(TLSFILE *tls,const char *fmt,...);
extern char *tls_fgets(char *s,int size,TLSFILE *tlsfile);
extern char *tls_getaddrname(TLSFILE *tlsfile,PEERTYP peer,char *unknown);
extern TLSFILE *tls_opentcp(char *addrname,int port,int swait);
extern int tls_waitforchar(TLSFILE *tlsfile,u_int millisec);
extern char *tls_waitforaction(int secwait,char *buffer,
			       int taille,TLSFILE *tlsfile);
extern int tls_iseof(TLSFILE *tlsfile);
extern u_long tls_idle(TLSFILE *tlsfile);
extern char **tls_getb64(char **lst,const char *b64);
#endif
