/************************************************/
/*						*/
/*      Copyright:				*/
/*		 Jean-Marc Pigeon <jmp@safe.ca>	*/
/*	Distributed under the Gnu Public	*/
/*	License, see the License file in this	*/
/*	package.				*/
/*						*/
/*	Define all routine to handle user status*/
/*	caching function.			*/
/*						*/
/************************************************/
#ifndef	UNICAC
#define UNICAC

typedef	enum	{
	pldsmstat,	/*payload SMTP status	*/
	pldaux		/*payload is a aux name	*/
	}PLDENUM;

typedef	struct	{	/*smtp status		*/
	int status;	/*numerical status	*/
	char *str;	/*string information	*/
	}SMSTTY;

typedef struct	{	
	PLDENUM type;	/*payload type		*/
	union	{
	  SMSTTY smstat;/*smtp status		*/
	  char *host[2];/*sender/check hostname	*/
	  }info;
	}PLDTYP;

extern void cac_setvalide(time_t valide);
extern void cac_setentry(char *recipient,PLDTYP *payload);
extern PLDTYP *cac_getentry(char *recipient,PLDENUM type);
extern void cac_expireentries();
extern void cac_cleanentries();
#endif
